﻿using HeuristicLab.Clients.Access.Administration;
using HeuristicLab.Clients.Hive.WebJobManager.Services;
using Microsoft.AspNet.SignalR;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace HeuristicLab.Clients.Hive.WebJobManager.Hubs
{
    public class CalendarHub : Hub
    {
        private WebLoginService weblog;
        private Guid userId;
        private HiveAdminClientWeb adminClient;
        private void loader()
        {
            weblog = WebLoginService.Instance;
            string uid = Context.QueryString["userid"];
            if (uid == null || uid == "" || Guid.Parse(uid) == Guid.Empty)
            {
                userId = Guid.Empty;
            }
            else
            {
                userId = Guid.Parse(uid);
                adminClient = weblog.getAdminClient(userId);
            }
        }
        public void requestInfo()
        {
            loader();
            adminClient.Refresh();
            
            var res = JsonConvert.SerializeObject(adminClient.Resources);
            Clients.Caller.processData(res);
        }
        public void requestDownTime(string id)
        {
            loader();
            adminClient.Refresh();
            Guid t = Guid.Parse(id);
            adminClient.DowntimeForResourceId = t;
            adminClient.RefreshCalendar();
            var down = JsonConvert.SerializeObject(adminClient.Downtimes);
            Clients.Caller.processDowntime(id, down);
        }
    }
}
