﻿
angular.module('wjm', ['ui.bootstrap', 'ui.calendar', 'angularTreeview']).

           controller('resourceCtrl', function ($scope, uiCalendarConfig, $compile, $timeout) {
               var vm = $scope;

               var date = new Date();

               var d = date.getDate();
               var m = date.getMonth();
               var y = date.getFullYear();
               var hubber = $.connection.calendarHub;
               vm.alertMessage = "No alerts";
               vm.currentcal = [];
               vm.selectedEventId = -1;

               vm.init = function () {

                   //  $.connection.hub.logging = true;


                   var v = document.getElementById("userId").innerHTML;
                   $.connection.hub.qs = { 'userid': v };
                   $.connection.hub.start().done(function () {
                       hubber.server.requestInfo();
                   });
                   hubber.client.processData = function (data) {
                       vm.data = JSON.parse(data);
                       $scope.buildTree();

                       $scope.$apply();
                   };
                   hubber.client.processDowntime = function (id, down) {
                       var json = JSON.parse(down);
                       var downtype = ["Unavailable", "Shutdown command"];
                       var arrdown = [];
                       console.log(json);
                       for (var i = 0; i < json.length; i++) {
                           arrdown.push({
                               id: json[i].Id,
                               title: 'offline',
                               start: json[i].StartDate,
                               end: json[i].EndDate,
                               allDay: json[i].AllDayEvent
                           });
                       }
                       var dat = { 'id': id, 'down': [arrdown] };
                       $scope.treeview.currentNode.calendar = dat;
                       $scope.currentcal = $scope.treeview.currentNode.calendar;
                       $scope.$apply();
                   }

                   $scope.$watch("treeview.currentNode", function (newValue, oldValue) {
                       $scope.currentcal = [];
                       $scope.selectedEventId = -1;
                       if ($scope.treeview.currentNode != null) {
                           if ($scope.treeview.currentNode.calendar.length === 0) {
                               hubber.server.requestDownTime(vm.treeview.currentNode.Id);
                           }
                           else {
                               $timeout(function () {
                                   $scope.currentcal = $scope.treeview.currentNode.calendar;
                                   $scope.$apply();
                               }, 0);
                               
                           }
                       }

                   });
               }
               $scope.buildTree = function () {
                   vm.tree = [];
                   vm.temptree = [];
                   vm.top = false;
                   for (; vm.data.length > 0;) {

                       if (vm.data[0].ParentResourceId == null) {
                           var curr = $scope.seekChildren(vm.data.splice(0, 1)[0]);
                           vm.tree.push(curr);
                       }
                       else {
                           var curr = $scope.seekChildren(vm.data.splice(0, 1)[0]);
                           vm.temptree.push(curr);
                       }
                   }
               };

               $scope.seekChildren = function (current) {
                   current.calendar = [];
                   current.children = [];
                   current.collapsed = true;
                   for (var t = 0; t < vm.temptree.length;) {
                       if (current.Id == vm.temptree[t].ParentResourceId) {
                           current.children.push(vm.temptree.splice(t, 1)[0]);
                       }
                       else {
                           t++;
                       }
                   }
                   var childc = current.children.length;//Remembers count of children received from temp tree;
                   for (var t = 0; t < vm.data.length;) {
                       if (current.Id == vm.data[t].ParentResourceId) {
                           current.children.push(vm.data.splice(t, 1)[0]);
                       }
                       else {
                           t++;
                       }
                   }
                   for (var t = childc; t < current.children.length; t++) {
                       current.children[t] = $scope.seekChildren(current.children[t]);
                   }
                   return current;
               }

               /* alert on eventClick */
               $scope.alertOnEventClick = function (date, jsEvent, view) {
                   vm.selectedEventId = date._id;
               };
               /* alert on Drop */
               $scope.alertOnDrop = function (event, delta, revertFunc, jsEvent, ui, view) {
                   vm.treeview.currentNode.calendar.down[0][event._id - 1].start = event.start;
                   if (vm.treeview.currentNode.calendar.down[0][event._id - 1].end != null)
                       vm.treeview.currentNode.calendar.down[0][event._id - 1].end = event.end;
               };
               /* alert on Resize */
               $scope.alertOnResize = function (event, delta, revertFunc, jsEvent, ui, view) {
                   vm.treeview.currentNode.calendar.down[0][event._id - 1].start = event.start;
                   vm.treeview.currentNode.calendar.down[0][event._id - 1].end = event.end;
               };

               /* add custom event*/
               $scope.addEvent = function () {
                   
               };
               $scope.calendarClick = function(date, jsEvent, view) {
                   console.log(date);
                   vm.treeview.currentNode.calendar.down[0].push({
                       id: '00000000-0000-0000-0000-000000000000',
                       title: 'offline',
                       start: date.toDate(),
                       end: null,
                       allDay: date._ambigTime,
                       color: '#378006',
                       _id: (vm.treeview.currentNode.calendar.down[0].length +1)
                   });
                   

               }
               /* remove event */
               $scope.remove = function (index) {
                   $scope.events.splice(index, 1);
               };
               /* Render Tooltip */
               $scope.eventRender = function (event, element, view) {
                   element.attr({
                       'tooltip': event.title,
                       'tooltip-append-to-body': true
                   });
                   //$compile(element)($scope);
               };
               /* config object */
               $scope.uiConfig = {
                   calendar: {
                       height: 600,
                       editable: true,
                       defaultView:'agendaWeek',
                       header: {
                           left: 'title',
                           center: '',
                           right: 'today prev,next'
                       },
                       timezone: 'UTC',
                       timeFormat: 'HH:mm',
                       eventClick: $scope.alertOnEventClick,
                       eventDrop: $scope.alertOnDrop,
                       eventResize: $scope.alertOnResize,
                       eventRender: $scope.eventRender,
                       dayClick: $scope.calendarClick

               
                   }
               };

           });


